program Algoritmo2_14;
(*
 * Algoritmo 2.14. Dibujar un cuadrado a partir de la posicion de los vertices
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 2. Secuenciacion y analisis de casos
 *)

uses crt, graph;

type
   Punto = record
                 abs : integer;   (* valores enteros en lugar de reales *)
                 ord : integer;
   end;
   Cuadrado = record
                    v1, v2, v3, v4 : Punto;
   end;

var
   c : Cuadrado;
   cg, mg : integer;        (* controlador y modo grafico *)

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 2.14. Dibujar un cuadrado a partir   *****');
     writeln('*****                 de la posicion de los vertices *****');
     writeln('*****');
     writeln;

(* E0: Indiferente *)

     writeln ('Introduzca los puntos de un cuadrado');
     write ('  Punto 1 (abscisa ordenada): ');
     readln (c.v1.abs, c.v1.ord);
     write ('  Punto 2 (abscisa ordenada): ');
     readln (c.v2.abs, c.v2.ord);
     write ('  Punto 3 (abscisa ordenada): ');
     readln (c.v3.abs, c.v3.ord);
     write ('  Punto 4 (abscisa ordenada): ');
     readln (c.v4.abs, c.v4.ord);

     InitGraph(cg,mg,'c:\tp');     (* inicializa modo grafico*)

(* E1: pos = (0, 0), dir = 0, trazo = Verdadero;
   los puntos de c son vertices de un cuadrado *)

    MoveTo(c.v1.abs, c.v1.ord);    (* mover al vertice v1 *)
(* E2: pos = c.v1, dir = 0, trazo = Verdadero *)
    LineTo(c.v2.abs,c.v2.ord);     (* mover al vertice v2 y traza linea *)
    LineTo(c.v3.abs,c.v3.ord);     (* mover al vertice v3 y traza linea *)
    LineTo(c.v4.abs,c.v4.ord);     (* mover al vertice v4 y traza linea *)
    LineTo(c.v1.abs,c.v1.ord);     (* mover al vertice v1 y traza linea *)
(* Ef: "cuadrado dibujado ", pos = c.v1, dir = 0, trazo = Verdadero *)
     readln;
     closeGraph;
end.

