program Algoritmo2_5;
(*
 * Algoritmo 2.5. Expresar una cantidad de bytes en megabytes y kilobytes
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 2. Secuenciacion y analisis de casos
 *)

uses crt;

var
   n : longint; 		(* dato, numero de bytes a descomponer *)
   mb : longint;		(* resultado, numero de megabytes *)
   kb : 0..1024;		(* resultado, numero de kilobytes *)
   b : 0..1024;			(* resultado, numero de bytes *)

procedure Convertir;
    (* PRE  0 <= n *)
    (* POST  (n = 1048576mb + 1024kb + b) y (0 <= kb < 1024) y (0 <= b < 1024) *)
    var
       rb : 0..1048575;	 (* resto de bytes *)

    begin
         mb := n div 1048576;
         rb := n mod 1048576;
    (* E1: n = 1048576 mb + rb y 0 <= rb < 1048576 *)
         kb := rb div 1024;
         b := rb mod 1024
    end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 2.5. Expresar una cantidad             *****');
     writeln('*****                de bytes en megabytes y kilobytes *****');
     writeln('*****');
     writeln;
     writeln('Descomposicion en bytes, kilobytes y megabytes');
     write('Introduzca un entero (>= 0): ');
     readln(n);
     Convertir;
     writeln('La descomposicion es:');
     writeln('    Megabytes: ', mb);
     writeln('    Kilobytes: ', kb);
     writeln('    Bytes: ', b);
     writeln;
     write('Pulse enter para continuar');
     readln
end.

