program Algoritmo3_1;
(*
 * Algoritmo 3.1. Calcular el perimetro de un cuadrilatero irregular (version 1)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 3. Acciones y funciones
 *)

uses crt;

type
    Coordenada = real;
    Punto = record
                  x : Coordenada;
                  y : Coordenada;
    end;
var
   p1, p2, p3, p4 : Punto;
   po, pd : Punto;
   dist, perimetro : real;

procedure Distancia;
(* PRE po y pd almacenan dos puntos *)
(* POST dist almacena la distancia entre los puntos po y pd *)
begin
     dist := sqrt(sqr(pd.x - po.x) + sqr(pd.y - po.y))
end;

procedure LeerPunto(var x, y : real; n : shortint);
begin
       write('  Coordenada x del punto ', n,': ');
       readln(x);
       write('  Coordenada y del punto ', n, ': ');
       readln(y);
       writeln
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 3.1. Calcular el perimetro de un        *****');
     writeln('*****                cuadrilatero irregular (version 1) *****');
     writeln('*****');
     writeln;
     writeln('Introduzca los puntos del cuadrilatero (en orden de adyacencia):');
     writeln;
     LeerPunto(p1.x, p1.y, 1);
     LeerPunto(p2.x, p2.y, 2);
     LeerPunto(p3.x, p3.y, 3);
     LeerPunto(p4.x, p4.y, 4);
     perimetro := 0.0;
(* E0 : perimetro = 0 *)

     po := p1;
     pd := p2;
     Distancia;
     perimetro := dist;
(* E1 : perimetro = Distancia (p1, p2) *)

     po := p2;
     pd := p3;
     Distancia;
     perimetro := perimetro + dist;
(* E2 : perimetro = Distancia (p1, p2) + Distancia (p2, p3) *)

     po := p3;
     pd := p4;
     Distancia;
     perimetro := perimetro + dist;
(* E3 : perimetro = Distancia (p1, p2) + Distancia (p2, p3) + Distancia (p3, p4) *)

     po := p4;
     pd := p1;
     Distancia;
     perimetro := perimetro + dist;
(* E4 : perimetro = Distancia (p1, p2) + Distancia (p2, p3) +
  		   Distancia (p3, p4) + Distancia (p4, p1) *)

     writeln('El perimetro del cuadrilatero irregular es: ', perimetro:1:2);
     writeln;
     write('Pulse enter para continuar');
     readln
end.

