program Algoritmo3_4;
(*
 * Algoritmo 3.4. Desplazamiento circular de tres variables
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 3. Acciones y funciones
 *)

uses crt;

var
   a, b, c : integer;

procedure Intercambiar(var x, y : integer);
(* PRE x, y : Entero, x = X, y = Y *)
(* POST  x = Y, y = X *)
var
   t : integer;
begin
     t := x;
     x := y;
     y := t
end;
begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 3.4. Desplazamiento circular de tres variables *****');
     writeln('*****');
     writeln;
(* PRE  a, b, c : Entero, a = A, b = B, c = C *)
(* POST  a, b, c : Entero, a = B, b = C, c = A *)
     writeln('Introduzca tres enteros separados por espacios');
     write('y termine pulsando enter: ');
     readln(a, b, c);
     writeln;
     writeln('Valor inicial de a, b y c: ', a, ', ',b, ' y ', c);
(* E0 : a = A, b = B, c = C *)
(* E0 = PRE *)

     Intercambiar(a, b);
(* E1 : a = B, b = A, c = C *)

     Intercambiar(b, c);
(* Ef : a = B, b = C, c = A => Post *)
     writeln;
     writeln('Desplazamiento circular a la izquierda');
     writeln;
     writeln('Valor final de a, b y c: ', a, ', ',b, ' y ', c);
     writeln;
     write('Pulse enter para continuar');
     readln
end.

