program Algoritmo3_6;
(*
 * Algoritmo 3.6. Calcular el perimetro de un cuadrilatero irregular (version 3)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 3. Acciones y funciones
 *)

uses crt;

type
    Coordenada = real;
    Punto = record
                  x : Coordenada;
                  y : Coordenada;
    end;
var
   p1, p2, p3, p4 : Punto;
   perimetro : real;

function Distancia(po, pd : Punto) : real;
(* PRE  po y pd almacenan dos puntos *)
(* POST  retorna la distancia entre los puntos po y pd *)
begin
     Distancia := sqrt(sqr(pd.x - po.x) + sqr(pd.y - po.y))
end;
procedure LeerPunto(var x, y : real; n : shortint);
begin
     write('  Coordenada x del punto ', n,':');
     readln(x);
     write('  Coordenada y del punto ', n, ':');
     readln(y);
     writeln;
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 3.6. Calcular el perimetro de un        *****');
     writeln('*****                cuadrilatero irregular (version 3) *****');
     writeln('*****');
     writeln;

     writeln('Introduzca los puntos del cuadrilatero:');
     writeln;
     LeerPunto(p1.x, p1.y, 1);
     LeerPunto(p2.x, p2.y, 2);
     LeerPunto(p3.x, p3.y, 3);
     LeerPunto(p4.x, p4.y, 4);

     perimetro := Distancia(p1, p2) + Distancia(p2, p3) + Distancia(p3, p4) + Distancia(p4, p1);

     writeln('El perimetro del cuadrilatero irregular es:', perimetro:1:2);
     writeln;
     write('Pulse enter para continuar');
     readln
end.

