program Algoritmo4_5;
(*
 * Algoritmo 4.5. Calcular el numero de pares ceros-unos en una secuencia de caracteres
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 4. La iteracion
 * Fichero de entrada: datos4_5.txt
 *)

uses crt, unitmsc1;

var
   s : MSC1;
   numCeros : integer;  (* lleva cuenta del numero de '0' *)
   numPares : integer;  (* lleva cuenta del numero de pares *)

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 4.5. Calcular el numero de pares ceros-unos *****');
     writeln('*****                en una secuencia de caracteres         *****');
     writeln('*****');
     writeln;
     TratamientoInicial_MSC1(s);
     Cargar_Fichero_MSC1(s,'datos4_5.txt');
     write('La secuencia de entrada es: ');
     Comenzar_MSC1(s);
     numCeros := 0;
     numPares := 0;
     (* INV y (EA = Primero (S)) *)
     while EA_MSC1(s) <> MSC1_MarcaFin do begin
     (* INV : numPares = NumPares (Piz), numCeros = NumCeros (Piz) *)
     (* INV y (EA_MSC1 <> MarcaFin) *)
           case EA_MSC1(s) of
                '0': numCeros := numCeros + 1;
                '1': numPares := numPares + numCeros
           end;
           write(EA_MSC1(s));
           Avanzar_MSC1(s)
     end;
     writeln;
     writeln;
     (* INV y (EA = MarcaFin), numPares = NumPares (S) *)
     writeln('El numero de pares 0-1 es: ', numPares);
     writeln;
     write('Pulse enter para continuar');
     readln
end.
