program Algoritmo5_12;
(*
 * Algoritmo 5.12. Control de trafico en una autopista
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 5. Tecnicas de disenyo de algoritmos
 * Fichero de entrada: dat5_12.txt
 *)

uses crt, unitmse1;

var
    numSegTotal : integer;
                (* Numero de segundos transcurridos durante el control *)
    numVehEnt : integer;
                (* Numero de vehiculos que han entrado en la autopista *)
    numSegInterMasLargo : integer;
                (* Intervalo de tiempo mas largo sin entrar vehiculos *)
    numSegInterActual : integer;
                (* Contador del numero de segundos del intervalo actual *)
    S : mse1;

begin
     clrscr;
     writeln;
     writeln ('*****');
     writeln ('***** Algoritmo 5.12  Control de trafico en una autopista *****');
     writeln ('*****');
     writeln;
     TratamientoInicial_MSE1(S);
     Cargar_fichero_MSE1(S,'dat5_12.txt');
     Comenzar_MSE1(S);
     numSegTotal := 0;
     numVehEnt := 0;
     numSegInterMasLargo := 0;
     write ('La secuencia de entrada es: ');
     while EA_MSE1(S) <> 0 do begin
       write(EA_MSE1(S), ' ');
       case EA_MSE1(S) of
         2 : begin
                  numVehEnt := numVehEnt + 1;
                  Avanzar_MSE1(S)
             end;
         1 : begin
                  numSegInterActual := 1;
       	  	  Avanzar_MSE1(S);
                  while not ((EA_MSE1(S) = 0) or
                            (EA_MSE1(S) = 2)) do begin
                        write(EA_MSE1(S), ' ');
                        if EA_MSE1(S) = 1 then
                           numSegInterActual := numSegInterActual + 1;
       		        Avanzar_MSE1(S);
                  end;
                  if numSegInterActual > numSegInterMasLargo then
                     numSegInterMasLargo := numSegInterActual;
                  numSegTotal := numSegTotal + numSegInterActual
             end;
         else Avanzar_MSE1(S);
       end;
     end;
     writeln;
     writeln;
     writeln('El tiempo total transcurrido es: ', numSegTotal);
     writeln;
     writeln('El numero de vehiculos que han circulado por la autopista es: ',
             numVehEnt);
     writeln;
     writeln('El intervalo de tiempo mas largo sin entrar un vehiculo es: ',
             numSegInterMasLargo);
     writeln;
     write('Pulse enter para continuar');
     readln
end.

