program Algoritmo5_8;
(*
 * Algoritmo 5.8. Calculo posicion de la primera palabra que comienza por 'a'
 *                (primer modelo, tercer esquema)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 5. Tecnicas de disenyo de algoritmos
 * Fichero de entrada: datos5_8.txt
 *)

uses crt, unitmsc1;

const
      ESPACIO = ' ';

var
      posicion : integer;
      anterior : char;
      S : msc1;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 5.8. Calculo posicion de la primera palabra               *****');
     writeln('*****                que comienza por "a" (primer modelo, tercer esquema) *****');
     writeln('*****');
     writeln;
     write('La secuencia de entrada es: ');
     TratamientoInicial_MSC1(S);
     Cargar_fichero_MSC1(S,'datos5_8.txt');
     Comenzar_MSC1 (S);
     while (EA_MSC1 (S) <> MSC1_MarcaFin) do begin
                write(EA_MSC1(S));
       		Avanzar_MSC1 (S)
     end;
     writeln;
     Comenzar_MSC1 (S);
     if EA_MSC1(S) = MSC1_MarcaFin then write('La secuencia esta vacia')
     else if EA_MSC1 (S) = 'a' then
             write('Posicion de la primera palabra que comienza por a es: ', 1)
     else begin
               posicion := 1;
               anterior := EA_MSC1 (S);
               (* Se utiliza la equivalencia ITERAR-MIENTRAS *)
               (* INV "En Piz ninguna palabra empieza por 'a'" y posicion = Long (Piz) *)
               Avanzar_MSC1 (S);
               while not ((EA_MSC1(S) = MSC1_MarcaFin) or
                         ((EA_MSC1(S) = 'a') and
                         (anterior = ESPACIO))) do begin
                     posicion := posicion + 1;
                     anterior := EA_MSC1(S);
                     Avanzar_MSC1 (S);
               end;
               writeln;
               if EA_MSC1(S) = MSC1_MarcaFin then
                   write('El texto no contiene ninguna palabra que comience por la letra a')
               else
                   write('Posicion de la primera palabra que comienza por "a" es: ', posicion+1)
     end;
     writeln;
     writeln;
     write('Pulse enter para continuar');
     readln
end.
