program Algoritmo5_9;
(*
 * Algoritmo 5.9. Comprobar si todas las palabras acaban con la misma letra
 *                (primer modelo, sin secuencia intermedia)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 5. Tecnicas de disenyo de algoritmos
 * Fichero de entrada: datos5_9.txt
 *)

uses crt, unitmsc1;

const
      ESPACIO = ' ';
var
      ultLetraPrimPal, anterior : char;
      S : msc1;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('*****  Algoritmo 5.9. Comprobar si todas las palabras acaban con la misma *****');
     writeln('*****                 letra (primer modelo, sin secuencia intermedia)     *****');
     writeln('*****');
     writeln;

(* Esquema de recorrido y busqueda.
   Encontrar letra final de la primera palabra *)
     TratamientoInicial_MSC1(S);
     Cargar_fichero_MSC1(S,'datos5_9.txt');
     write('La secuencia de entrada es: ');
     Comenzar_MSC1 (S);
     while (EA_MSC1 (S) <> MSC1_MarcaFin) do begin
                write(EA_MSC1(S));
       		Avanzar_MSC1 (S)
     end;
     writeln;
     Comenzar_MSC1(S);
     anterior := ESPACIO;
     while (EA_MSC1(S) <> MSC1_MarcaFin) and
           not ((EA_MSC1(S) = ESPACIO) and (anterior <> ESPACIO)) do begin
               anterior := EA_MSC1(S);
               Avanzar_MSC1(S)
     (* INV anterior = "ultimo elemento de Piz" y
           "no hay ningun par (letra, espacio) en Piz" *)
     end;
     writeln;
     if (EA_MSC1(S) = MSC1_MarcaFin) and (anterior = ESPACIO) then
	write('No hay palabras en la secuencia')
     else if (EA_MSC1(S) = MSC1_MarcaFin) then
       (* Slo hay una palabra y anterior <> ESPACIO *)
       write('Todas las palabras terminan en la misma letra')
     else begin
       (* EA (S) es un espacio en blanco
         Esquema de recorrido y busqueda.
         Comprobar en el resto de la secuencia *)
         ultLetraPrimPal := anterior;
         anterior := EA_MSC1(S);
         Avanzar_MSC1(S);
         while (EA_MSC1(S) <> MSC1_MarcaFin) and
               not ((EA_MSC1(S) = ESPACIO) and (anterior <> ESPACIO) and
               (anterior <> ultLetraPrimPal)) do begin
                         anterior := EA_MSC1(S);
                         Avanzar_MSC1(S)
         (* INV anterior = "ultimo elemento de Piz" y
           "no hay ningun par (letra, espacio) en Piz
            tal que letra <> ultLetraPrimPal" *)
         end;
         if (EA_MSC1(S) = MSC1_MarcaFin) and ((anterior = ultLetraPrimPal)
            or (anterior = ESPACIO)) then
             write('Todas las palabras terminan en la misma letra')
         else
             write('Todas las palabras no terminan en la misma letra')
     end;
     writeln;
     writeln;
     write('Pulse enter para continuar');
     readln
end.

