program Algoritmo6_13;
(*
 * Algoritmo 6.13. Metodo de ordenacion de insercion directa
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 6. Tablas
 *)

(* Metodo de ordenacion de insercion directa *)

uses crt;

const
     LMAX = 100;

type
     Rango = 0..LMAX;
     Vector = array [Rango] of integer;

var
   t: Vector;
   q, j : Rango;
   n : Rango;
   x : integer;

procedure Leer(VAR a : Vector; n : Rango);
var
   i : Rango;
begin
     for i := 1 to n do begin
         write('  Introduzca elemento ',i,': ');
         readln(a[i]);
     end
end;

procedure Escribir(a : Vector; n : Rango);
var
   i : Rango;
begin
     for i := 1 to n do
         write(a[i],' ');
     writeln
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 6.13. Metodo de ordenacion de insercion directa *****');
     writeln('*****');
     writeln;
     write('Introduzca el numero de elementos: ');
     readln(n);
     Leer(t, n);

     writeln;
     write('Los elementos iniciales son: ');
     Escribir(t,n);

     for q := 2 to n do begin
         t[0] := t[q];		        (* centinela *)
	      x := t[q];
	      j := q - 1;
	      while x < t[j] do begin
	            t[j+1] := t[j];   	        (* desplazamiento *)
		    j := j - 1
	      end;
	      t[j+1] := x;
     end;

     writeln;
     write('Los elementos ordenados son: ');
     Escribir(t,n);
     writeln;
     write('Pulse enter para continuar');
     readln
end.

