program Algoritmo6_14;
(*
 * Algoritmo 6.14. Metodo de ordenacion de seleccion directa
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 6. Tablas
 *)

(* Metodo de ordenacion de seleccion directa *)

uses crt;

const
     LMAX = 100;
type
    Rango = 1..LMAX;
    Vector = array [Rango] of integer;
var
   t : Vector;
   pos, q, j : Rango;
   n : Rango;
   min : integer;

procedure Leer(VAR a:Vector; n:Rango);
var
   i:Rango;
begin
     for i:=1 to n do begin
         write('  Introduzca elemento ',i,': ');
         readln(a[i]);
     end;
end;

procedure Escribir(a:Vector; n:Rango);
var
   i:Rango;
begin
     for i:=1 to n do
         write(a[i],' ');
     writeln;
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 6.14. Metodo de ordenacion de seleccion directa *****');
     writeln('*****');
     writeln;

     write('Introduzca el numero de elementos: ');
     readln(n);
     Leer(t, n);

     writeln;
     write('Los elementos iniciales son: ');
     Escribir(t,n);

     for q := 1 to n - 1 do begin
         pos := q;
	 min := t[q];
         for j := q+1 to n do
	     if min > t[j] then begin
	                             pos := j;
			             min := t[j];
	     end;
	 t[pos] := t[q];
	 t[q] := min;
     end;

     writeln;
     write('Los elementos ordenados son: ');
     Escribir(t,n);
     writeln;
     write('Pulse enter para continuar');
     readln
end.