program Algoritmo6_15;
(*
 * Algoritmo 6.15. Busqueda binaria en un tabla ordenada
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 6. Tablas
 *)

(* Busqueda binaria en un tabla ordenada *)

uses crt;

const
     LMAX = 100;
type
    Rango = 1..LMAX;
    Vector = array [Rango] of integer;
var
   n : Rango;
   t : Vector;
   i : 0..LMAX;
   j : 1..LMAX+1;
   h : Rango;
   x: integer;

procedure Leer(VAR a : Vector; n : Rango);
var
   i:Rango;

begin
     for i := 1 to n do begin
         write('  Introduzca elemento ',i,': ');
         readln(a[i]);
     end;
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 6.15. Busqueda binaria en un tabla ordenada *****');
     writeln('*****');
     writeln;
     write('Introduzca el numero de elementos (maximo ', LMAX, '): ');
     readln(n);
     Leer(t, n);
     writeln;
     write('Introduzca el elemento a buscar: ');
     readln(x);
     i := 0;
     j := n + 1;
     while (i + 1) <> j do begin
           h := (i + j) div 2;
           if t[h] <= x then i := h
           else j := h;
     end;
     writeln;
     write('La secuencia de entrada es: ');
     for h := 1 to n do begin
         write (t[h], ' ');
     end;
     writeln;
     writeln;
     if (i > 0) and (x = t[i]) then
         writeln('Valor encontrado en la posicion: ', i )
     else
         writeln('Valor no encontrado');
     writeln;
     write('Pulse enter para continuar');
     readln
end.
