program Algoritmo6_4;
(*
 * Algoritmo 6.4. Calcular distribucion de las notas
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 6. Tablas
 * Fichero de entrada: datos6_4.dat
 *)

(* Para generar el fichero datos6_4.dat emplear el programa genf6_4.pas   *)
(* Para consultar el fichero datos6_4.dat emplear el programa verf6_4.pas *)

uses crt;

const
    NUM_NOTAS = 5;
    MAX_ESTUDIANTES = 100;
type
    Estudiante = record
                       nombre : string;
		       edad : integer;
		       sexo : boolean;
		       nota : real;
    end;
    Festudiantes = file of Estudiante;
    Curso = array [1..MAX_ESTUDIANTES] of Estudiante;
var
   f : Festudiantes;
   c : Curso;
   fNotas : array [1..NUM_NOTAS] of integer;
   i, k : 1..MAX_ESTUDIANTES;
   j : 1..NUM_NOTAS;

procedure Escribe(i : integer);
begin
     case i of
     1 : write('Numero de suspensos: ');
     2 : write('Numero de aprobados: ');
     3 : write('Numero de notables: ');
     4 : write('Numero de sobresalientes: ');
     5 : write('Numero de matriculas de honor: ');
     end;
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 6.4. Calcular distribucion de las notas *****');
     writeln('*****');
     writeln;
     assign(f,'datos6_4.dat');
     reset(f);
     k := 1;
     while (not eof(f)) and (k <= MAX_ESTUDIANTES) do begin
           read(f,c[k]);
           k := k + 1;
     end;
     close(f);
     (* Comenzar *)
     i := 1;

     (* Tratamiento inicial *)
     for j := 1 to NUM_NOTAS do
         fNotas[j] := 0;

     (* Tratamiento de cada elemento de la tabla *)
     while i <> k do begin
           if (c[i].nota) < 5 then fNotas[1] := fNotas[1] + 1
           else if (c[i].nota >= 5) and (c[i].nota < 7) then fNotas[2] := fNotas[2] + 1
           else if (c[i].nota >= 7) and (c[i].nota < 9) then fNotas[3] := fNotas[3] + 1
           else if c[i].nota = 9 then fNotas[4] := fNotas[4] + 1
           else fNotas[5] := fNotas[5] + 1;
           (* Avanzar *)
           i := i+1;
     end;

     (* Tratamiento final *)
     for j := 1 to NUM_NOTAS do begin
         Escribe(j);
         writeln(fNotas[j]);
     end;
     writeln;
     write('Pulse enter para continuar');
     readln
end.

