program Algoritmo6_9;
(*
 * Algoritmo 6.9. Calcular la fecha a partir de la posicion del dia en el anyo (version 2)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 6. Tablas
 *)

uses crt;

type
    MesAyo = 1..12;
    DiaAyo = 1..365;
    Diames = 1..31;

const
    tp : array [MesAyo] of integer = (1, 32, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335);

var
    p : DiaAyo;
    i : MesAyo;
    mes : MesAyo;
    dia : Diames;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 6.9. Calcular la fecha a partir de la posicion *****');
     writeln('*****                del dia en el anyo (version 2)            *****');
     writeln('*****');
     writeln;
     write('Introduzca la posicion del dia en el anyo: ');
     readln(p);
     if p >= tp[12] then mes := 12
     else begin
               i := 2;
      	       while tp[i] <= p do
               (* INV: j: 1 <= j < i : p >= tp[j] *)
                     i := i + 1;
               mes := i - 1;
     end;
     dia := p - tp[mes] + 1;
     writeln;
     writeln('Dia ',dia,' del mes ', mes);
     writeln;
     write('Pulse enter para continuar');
     readln
end.