program GenF6_1;
(*
 * Algoritmo GenF6_1. Genera el fichero datos6_1.dat
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 6. Tablas
 *)

(* En este algoritmo se ha sustituido la secuencia de NotaAlumno
   por un fichero secuencial, 'datos6_1.dat' *)

uses crt;

const
     MAX_ALUMNOS = 200;

type
    NotaAlumno = record
                       codigo : 1..MAX_ALUMNOS;
                       nota : Real;
                 end;
var
    f : file of NotaAlumno;
    alum : NotaAlumno;
    x: char;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo GenF6_1. Genera el fichero datos6_1.dat *****');
     writeln('*****');
     writeln;
     assign(f,'datos6_1.dat');
     rewrite(f);
     repeat
           writeln;
           write('Introduzca el codigo del alumno (>= 1) (<= ', MAX_ALUMNOS, '): ');
           readln(alum.codigo);
           write('Introduzca la nota del alumno: ');
           readln(alum.nota);
           write(f, alum);
           write('Desea introducir mas notas s/S (si),n/N (no)?: ');
           readln(x);
      until x in ['n','N'];
      close(f);
      writeln;
      write('Pulse enter para continuar');
      readln

end.
