program GenF6_4;
(*
 * Algoritmo GenF6_4. Genera el fichero datos6_4.dat
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 6. Tablas
 * Fichero de salida: datos6_4.dat
 *)

uses crt;

const
     MarcaFinNotas = -1;
type
    Estudiante = record
                       nombre : string;
		       edad : integer;
		       sexo : boolean;
		       nota : real;
    end;
    Festudiantes = file of Estudiante;

var
   f : Festudiantes;
   est : Estudiante;
   x: char;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo GenF6_4. Genera el fichero datos6_4.dat *****');
     writeln('*****');
     writeln;
     assign (f,'datos6_4.dat');
     rewrite(f);
     (*  Se introducen los datos de los estudiantes en la tabla *)
     writeln('Introduzca los datos de los estudiantes (nota=-1 para terminar)');
     writeln;
     write(' Introduzca nota: '); readln(est.nota);
     while est.nota <> MarcaFinNotas do begin
           write(' Introduzca el nombre: '); readln(est.nombre);
           write(' Introduzca la edad: '); readln(est.edad);
           repeat
                 write(' M/m mujer, H/h hombre: ');
                 readln(x);
           until x in ['m','M','h','H'];
           est.sexo := (x='M') or (x='m');
           write(f,est);
           writeln;
           write(' Introduzca nota: '); readln(est.nota);
     end;
     close(f);
     writeln;
     write('Pulse enter para continuar');
     readln

end.
