program VerF6_4;
(*
 * Algoritmo VerF6_4. Consulta todo el fichero datos6_4.dat
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 6. Tablas
 * Fichero de entrada: datos6_4.dat
 *)

uses crt;
type
   Estudiante = record
                      nombre : string;
		      edad : integer;
		      sexo : boolean;
		      nota : real;
   end;
   Festudiantes = file of Estudiante;

var
   f : Festudiantes;
   est : Estudiante;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo VerF6_4. Consulta todo el fichero datos6_4.dat *****');
     writeln('*****');
     writeln;
     assign (f,'datos6_4.dat');
     reset(f);
     writeln('** Datos de los estudiantes (pulse enter para ver siguiente) **');
     writeln;
     while not eof(f) do begin
           read(f,est);
           writeln('  nombre: ', est.nombre);
           writeln('  edad: ', est.edad);
           write('  sexo: ');
           case est.sexo of
                TRUE:  writeln('mujer');
                FALSE:  writeln('hombre');
           end;
           writeln('  nota: ', est.nota:1:2);
           readln
     end;
     close(f);
     writeln;
     write('Pulse enter para continuar');
     readln
end.
