program Algoritmo7_12;
(*
 * Algoritmo 7.12. Funcion division natural mejorada
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 7. Disenyo recursivo
 *)

uses crt;

var
   dividendo, divisor, cociente, resto : integer;
(*
 * Pascal no admite que una funcion devuelve un valor de un tipo registro,
 * Por este motivo la funcion DivNat se ha convertido en un procedimiento
 * con dos parametros paso por variable
 *)
procedure DivNat(num, den : integer; VAR coc, res : integer);
(*
 * PRE: (num >= 0) y (den > 0)
 * POST: DivNat (num, den, c, r) y num = coc * den + res y 0 <= res < den
 *)
begin
     if num < den then
     begin
          coc := 0;
          res := num
     end
     else
     begin
          DivNat(num, den * 2, coc, res);
          coc := coc * 2;
          if res >= den then
          begin
               coc := coc + 1;
               res := res - den
          end
     end
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 7.12. Funcion division natural mejorada *****');
     writeln('*****');
     writeln;
     write('Introduzca el dividendo (>= 0): ');
     readln(dividendo);
     writeln;
     write('Introduzca el divisor (> 0): ');
     readln(divisor);
     DivNat(dividendo, divisor, cociente, resto);
     writeln;
     writeln('Resultado: cociente = ', cociente, ', resto = ', resto);
     writeln;
     write ('Pulse enter para continuar');
     readln

end.




