program Algoritmo7_4;
(*
 * Algoritmo 7.4. Funcion producto escalar recursiva lineal final
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 7. Disenyo recursivo
 *)

uses crt;

const
     MAX = 10;

type
    Vector = array [1..MAX] of real;

var
   vv1, vv2 : Vector;
   n, i : integer;

function  peii (v1, v2 : Vector; a, b : integer; c : real) : real;
(* PRE 1 <= a <= b <= MAX, y v1 y v2 tienen valores significativos en [a, b] *)
(* POST  pei (v1, v2, a, b, c) = c + sumatorio desde i = a hasta b de v1[i] * v2[i] *)
begin
	if a = b then peii := c + v1[a] * v2[a]
	else (* a < b *) peii := peii (v1, v2, a+1, b, c + v1[a] * v2[a])
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 7.4. Funcion producto escalar recursiva lineal final *****');
     writeln('*****');
     writeln;
     write('Introduzca el numero de elementos de los vectores (> 0) y (<=',MAX,'): ');
     readln(n);
     writeln;
     writeln('Primer vector');
     for i := 1 to n do begin
        write('   Componente ', i, ': ');
        readln(vv1[i]);
     end;
     writeln;
     writeln('Segundo vector');
     for i := 1 to n do begin
        write('   Componente ', i, ': ');
        readln(vv2[i]);
     end;
     writeln;
     writeln('El producto escalar de los vectores es: ', peii (vv1, vv2, 1, n, 0):1:2);
     writeln;
     write('Pulse enter para continuar');
     readln;
end.


