program Algoritmo2_11;
(*
 * Algoritmo 2.11. Comprobar si una fecha es correcta (version 1)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 2. Secuenciacion y analisis de casos
 *)

uses crt;

var
   dia : word;
   mes : word;
   anyo : word;
   esBisiesto : boolean;        (* indicador de anyo bisiesto *)
   fechaValida : boolean;	(* indicador de fecha valida *)

procedure AnyoBisiesto;
(* POST  esBisiesto es Verdadero si el anyo es bisiesto y Falso en caso contrario *)
   begin
        esBisiesto := (anyo mod 4 = 0) and (anyo mod 100 <>  0) or
                      (anyo mod 400 = 0) and (anyo <> 3600)
   end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('*****  Algoritmo 2.11. Comprobar si una fecha es correcta (version 1) *****');
     writeln('*****');
     writeln;
     write('Introduzca el dia: ');
     readln(dia);
     write('Introduzca el mes: ');
     readln(mes);
     write('Introduzca el anyo: ');
     readln(anyo);
     fechaValida := true;
     if dia < 1 then fechaValida := false
     else
         case mes of
    	      1, 3, 5, 7, 8, 10, 12:	(* meses de 31 dias *)
	                  if dia > 31 then fechaValida := false;
	      4, 6, 9, 11: 		(* meses de 30 dias *)
	                  if dia > 30 then fechaValida := false;
    	      2: 			(* mes de febrero *)
                          begin
	                       AnyoBisiesto;
		               if (dia > 29) or (not esBisiesto and (dia > 28))
			          then fechaValida := false
                          end
              else fechaValida := false
	 end;
     write (dia, '/', mes, '/', anyo);
     if fechaValida then writeln(' es una fecha valida')
                    else writeln(' no es una fecha valida');
     writeln;
     write('Pulse enter para continuar');
     readln
end.

