program Algoritmo2_12;
(*
 * Algoritmo 2.12. Comprobar si una fecha es correcta (version 2)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 2. Secuenciacion y analisis de casos
 *)

uses crt;

var
   dia : word;
   mes : word;
   anyo : word;
   esBisiesto : boolean;        (* indicador de anyo bisiesto *)
   fechaValida : boolean;	(* indicador de fecha valida *)

		(*  igual que en Algoritmo 2.11 *)

procedure AnyoBisiesto;
(* POST  esBisiesto es Verdadero si el anyo es bisiesto y Falso en caso contrario *)
   begin
        esBisiesto := (anyo mod 4 = 0) and (anyo mod 100 <>  0) or
                      (anyo mod 400 = 0) and (anyo <> 3600)
   end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 2.12. Comprobar si una fecha es correcta (version 2) *****');
     writeln('*****');
     writeln;
     write('Introduzca el dia: ');
     readln(dia);
     write('Introduzca el mes: ');
     readln(mes);
     write('Introduzca el anyo: ');
     readln(anyo);
     if dia < 1 then fechaValida := false
     else
         case mes of
    	            1, 3, 5, 7, 8, 10, 12:  fechaValida := dia <= 31;
	            4, 6, 9, 11: fechaValida := dia <= 30;
    	            2: begin
                          AnyoBisiesto;
                          fechaValida := (dia <= 29) and (esBisiesto or (dia <= 28));
                       end
	            else fechaValida := false
	 end;
     write (dia, '/', mes, '/', anyo);
     if fechaValida then writeln( ' es una fecha valida')
                    else writeln( ' no es una fecha valida');
     writeln;
     write('Pulse enter para continuar');
     readln
end.

