program Algoritmo2_15;
(*
 * Algoritmo 2.15. Comprobar si una fecha es correcta (version 3)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Capitulo 2. Secuenciacion y analisis de casos
 *)

uses crt;

(*$R+*)

type
    Fecha = record
                  dia : 1..31;
                  mes : 1..12;
                  anyo : word
    end;
var
   f : Fecha;			(* dato, fecha dia/mes/anyo *)
   esBisiesto : boolean;	(* indicador de anyo bisiesto *)
   fechaValida : boolean;	(* indicador de fecha valida *)

   procedure AnyoBisiesto;
   (* POST  esBisiesto es Verdadero si f.anyo es bisiesto y Falso en caso contrario *)

   begin
        esBisiesto := (f.anyo mod 4 = 0) and (f.anyo mod 100 <> 0) or
                      (f.anyo mod 400 = 0) and (f.anyo <> 3600)
   end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 2.15. Comprobar si una fecha es correcta (version 3) *****');
     writeln('*****');
     writeln;
     write('Introduzca el dia: ');
     readln(f.dia);
     write('Introduzca el mes: ');
     readln(f.mes);
     write('Introduzca el anyo: ');
     readln(f.anyo);
     case f.mes of
          1, 3, 5, 7, 8, 10, 12: fechaValida := true;
          4, 6, 9, 11: fechaValida := f.dia <> 31;
          2: begin
                  AnyoBisiesto;
                  fechaValida := (f.dia <= 29) and (esBisiesto or (f.dia <> 29))
             end;
     end;
     write (f.dia, '/', f.mes, '/', f.anyo);
     if fechaValida then writeln(' es una fecha valida')
                    else writeln(' no es una fecha valida');
     writeln;
     write('Pulse enter para continuar');
     readln

end.

