program Algoritmo2_4;
(*
 * Algoritmo 2.4. Calculo del salario neto de un trabajador (version 2)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 2. Secuenciacion y analisis de casos
 *)

uses crt;
const
     IMPUESTO = 0.20;
     SEGURO_MEDICO = 0.05;
     COMPLEMENTO_QUINQUENIO = 60;
     COMPLEMENTO_ANYO = 6;
var
     salarioBase : word;	(* dato, sueldo base del trabajador *)
     antiguedad : word;		(* dato, anyos en la empresa *)
     salarioNeto : real;	(* resultado, salario percibido por el trabajador *)
     salarioBruto : word; 	(* salario bruto del trabajador *)
     descuentos : real; 	(* descuentos aplicados *)
     numeroQuinquenios : word;
     numeroAnyos : word;
     pagoQuinquenios : word;
     pagoAnyos : word;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 2.4. Calculo del salario neto de *****');
     writeln('*****                un trabajador (version 2)   *****');
     writeln('*****');
     writeln;
     write('Introduzca el salario base: ');
     readln(salarioBase);
     write('Introduzca la antiguedad: ');
     readln(antiguedad);

     (* Calculo del salario bruto *)
     numeroQuinquenios := antiguedad div 5;
     numeroAnyos := antiguedad mod 5;

     pagoQuinquenios := numeroQuinquenios * COMPLEMENTO_QUINQUENIO;
     pagoAnyos := numeroAnyos * COMPLEMENTO_ANYO;
     salarioBruto := salarioBase + pagoQuinquenios + pagoAnyos;

     (* Calculo de los descuentos y el salario neto *)
     descuentos := salarioBruto * (IMPUESTO + SEGURO_MEDICO);
     salarioNeto := salarioBruto - descuentos;

     writeln('El sueldo neto es: ', salarioNeto:1:2);
     writeln;
     write('Pulse enter para continuar');
     readln
end.
