program Algoritmo3_11;
(*
 * Algoritmo 3.11. Comprobar si una fecha es valida (version 3)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 3. Acciones y funciones
 *)

uses crt;

(*$R+*) (* Habilita la comprobacion de intervalos *)
(* $Q+  Habilita la comprobacion de desbordamiento (solo en version 7.0) *)

const
	diasMes : array [1..12] of integer =
                (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

type
	Fecha = record
                       dia : 1..31;
                       mes : 1..12;
                       anyo : word;
        end;
var
	f : Fecha; (* fecha dia/mes/anyo *)

function AnyoBisiesto(anyo : integer) : boolean;
         (* PRE  anyo es un entero *)
	 (* POST  AnyoBisiesto es verdad si anyo es bisiesto
                 y falso en caso contrario *)
begin
     AnyoBisiesto := (anyo mod 4 = 0) and (anyo mod 100 <> 0) or
                     (anyo mod 400 = 0) and (anyo <> 3600);
end;

begin
     clrscr;
     writeln('Introduzca una fecha');
     writeln;
     write('Introduzca el dia: ');
     readln(f.dia);
     write('Introduzca el mes: ');
     readln(f.mes);
     write('Introduzca el anyo: ');
     readln(f.anyo);

     if AnyoBisiesto(f.anyo) then diasMes[2] := 29;
     write(f.dia, '/', f.mes, '/', f.anyo, ' ');
     if (f.dia <= diasMes[f.mes]) then writeln('es una fecha valida')
     else writeln('no es una fecha valida');
     writeln;
     write('Pulse enter para continuar');
     readln
end.
