program Algoritmo3_5;
(*
 * Algoritmo 3.5. Algoritmo para dibujar dos cuadrados encajados
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 3. Acciones y funciones
 *)

uses crt, graph3;

type
    Coordenada = integer; (* En Pascal las coordenadas son valores enteros *)
    Punto = record
                  x : Coordenada;
                  y : Coordenada;
    end;
    Cuadrado = record
                     pos : Punto;
                     lado, ang : integer
    end;
var
   ce : Cuadrado;

procedure DibujarCuadrado(c : Cuadrado);
     (* PRE  Pantalla y pluma indiferentes *)
     (* POST  "cuadrado c dibujado", PE = Baja, PP = c.pos, ORI = c.ang *)

var
   i : integer;
begin
     PenUp;
     SetPosition(c.pos.x, c.pos.y);
     SetHeading(c.ang);
     PenDown;
     for i := 1 to 4 do begin
             Forwd(c.lado);
             TurnRight(90);
     end;
end;

procedure Leer(var c : Cuadrado);
begin
       writeln('  CUADRADO');
       write('  Coordenada x del punto origen: ');
       readln(c.pos.x);
       write('  Coordenada y del punto origen: ');
       readln(c.pos.y);
       write('  Lado del cuadrado: ');
       readln(c.lado);
       write('  Angulo del cuadrado (grados): ');
       readln(c.ang);
       writeln;
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 3.5. Algoritmo para dibujar dos cuadrados encajados *****');
     writeln('*****');
     writeln;
     Leer(ce);
     GraphMode;          (* 320 x 200 modo grafico blanco-negro *)
     ClearScreen;
     ShowTurtle;
     DibujarCuadrado(ce);
     ce.lado := ce.lado div 2;
     DibujarCuadrado(ce);
     writeln;
     write('Pulse enter para continuar');
     readln
end.

