program Algoritmo4_11;
(*
 * Algoritmo 4.11. Calculo de las potencias de 2 (version 1)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 4. La iteracion
 *)

uses crt;

var
   x : integer;         (* indice inferior del intervalo de potencias *)
   y : integer;         (* indice superior del intervalo *)
   i : integer;

function Potencia2(n : integer):longint;
(* PRE: n : Entero >= 0 *)
(* POST: Potencia2 = 2^n *)
var
   p : longint;
   j : integer;
begin
     p := 1;
     for j := 1 to n do
         p := p * 2;
        (* INV  p = 2^j  *)
     Potencia2 := p
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 4.11. Calculo de las potencias de 2 (version 1) *****');
     writeln('*****');
     writeln;
     write('Introduzca dos enteros (>= 0) en orden creciente separados por blancos: ');
     readln(x, y);
     writeln;
     for i := x to y do
         writeln('La potencia ', i, '-esima de 2 es ', Potencia2(i));
         (* INV se han calculado y mostrado las potencias de 2
            en el intervalo [x,i] *)
     writeln;
     write('Pulse enter para continuar');
     readln
end.

