program Algoritmo4_13;
(*
 * Algoritmo 4.13. Calculo del termino enesimo de la sucesion de Fibonacci
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 4. La iteracion
 *)

uses crt;

var
   ult, penult : longint;        (* ultimo y penultimo termino de Fibonacci *)
   copiaFibo : longint;          (* valor Fibonacci en el paso i-1 *)
   fibo : longint;               (* resultado *)
   n : integer;                  (* dato *)
   i :integer;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 4.13. Calculo del termino enesimo *****');
     writeln('*****                 de la sucesion de Fibonacci *****');
     writeln('*****');
     writeln;
     write('Introduzca un entero (>= 0): ');
     readln(n);
     writeln;
     case n of
          0 :   writeln('El termino ',n,'-esimo de la sucesion (posicion ', n+1,') es: 1');
          1 :   writeln('El termino ',n,'-esimo de la sucesion (posicion ', n+1,') es: 1');
          else	penult := 1; ult := 1; fibo := 2;
                for i:=3 to n do begin
                    copiaFibo := fibo;
                    fibo := fibo + ult;
                    penult := ult;
                    ult := copiaFibo
                    (* INV  (fibo = f(i)) y (ult = f(i-1)) y (penult = f(i-2)),
                             3 <= i <= n *)
                end;
                (* INV y (i = n) *)
                writeln('El termino ',n,'-esimo de la sucesion (posicion ', n+1,') es: ', fibo)
     end;
     writeln;
     write('Pulse enter para continuar');
     readln
end.
