program Algoritmo4_18;
(*
 * Algoritmo 4.18. Calcular 1/x a partir de una sucesion recurrente
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 4. La iteracion
 *)

uses crt;

var
   x : real;            (* dato entre 0 y 1 *)
   a : real;            (* resultado *)
   c : real;            (* para el calculo de la sucesion *)
   eps : real;          (* error *)

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 4.18. Calcular 1/x a partir de una sucesion recurrente *****');
     writeln('*****');
     writeln;
     write('Introduzca un valor real (<= 1) y (> 0): ');
     readln (x);
     writeln;
     write('Introduzca el error permitido: ');
     readln(eps);
     a := 1; c := 1 - x;
     while (c > eps) do begin
           a := a * (1 + c);
           c := c * c;
     end;
     writeln;
     writeln('El resultado de evaluar la expresion 1/',x, ' es: ',a);
     writeln;
     write('Pulse enter para continuar');
     readln
end.

