program Algoritmo4_4;
(*
 * Algoritmo 4.4. Calcular el valor medio de una secuencia con las notas de una asignatura
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 4. La iteracion
 * Fichero de entradas: datos4_4.txt
 *)

uses crt, unitmsr1;

var
   s : msr1;
   suma : real; (* lleva cuenta de la suma total de las notas *)
   numElem : integer; (*  lleva cuenta del numero de notas *)

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 4.4. Calcular el valor medio de una secuencia *****');
     writeln('*****                con las notas de una asignatura          *****');
     writeln('*****');
     writeln;
     TratamientoInicial_MSR1(s);
     Cargar_Fichero_MSR1(s,'datos4_4.txt');
     write('La secuencia de entrada es: ');
     Comenzar_MSR1(s);
     suma := 0.0;
     numElem := 0;

(* Eini : suma = 0 y numElem = 0 y ea = Primero (S) y INV = Verdadero *)
     while EA_MSR1(s) <> MSR1_MarcaFin do begin
     (* INV  1 <= i <= Long (Piz) y suma tiene el *)
     (* sumatorio desde i=1 hasta Long(Piz) de Si *)
     (* y numElem = Long (Piz) y (EA (S) <> MarcaFin) *)
           suma := suma + EA_MSR1(s);
           numElem := numElem + 1;
           write(EA_MSR1(s):1:2, ' ');
	   Avanzar_MSR1(s);
     end;
(* Efin : INV y (EA (S) = MarcaFin) *)
     writeln;
     writeln;
     if (numElem > 0) then write('Valor medio de las notas = ', suma/numElem:1:2)
     else write('Secuencia vacia');
     writeln;
     writeln;
     write('Pulse enter para continuar');
     readln
end.
