program Algoritmo5_10;
(*
 * Algoritmo 5.10. Comprobar si todas las palabras acaban con la misma letra
 *                 (primer modelo, con secuencia intermedia formada por las
 *                 ultimas letras de cada palabra)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 5. Tecnicas de disenyo de algoritmos
 * Fichero de entrada: dat5_10.txt
 *)

uses crt, unitmsc1;

const
      ESPACIO = ' ';
var
      ultLetra : char;
      FinDeSecuenciaUltLetra : boolean;
      ultLetraPrimPal : char;
      S : msc1;

procedure ObtenerUltimo;
          (* POST ultLetra es la ltima letra de la siguiente palabra,
                 si la hay, y se actualiza FinDeSecuenciaUltLetra *)
     procedure IgnorarEspacios;
               (* POST EA es la siguiente letra, si la hay *)
     begin
          while (EA_MSC1(S) <> MSC1_MarcaFin) and (EA_MSC1(S) = ESPACIO) do
                Avanzar_MSC1(S);
     end;
begin
     IgnorarEspacios;
     if (EA_MSC1(S) = MSC1_MarcaFin) then FinDeSecuenciaUltLetra := true
     else begin
       FinDeSecuenciaUltLetra := False;
       REPEAT
             ultLetra := EA_MSC1(S);
             Avanzar_MSC1(S)
       UNTIL (EA_MSC1(S) = MSC1_MarcaFin) or (EA_MSC1(S) = ESPACIO);
     end;
end;

procedure ComenzarUltLetra;
          (* POST ultLetra es la ultima letra de la primera palabra,
            si la hay, y se actualiza FinDeSecuenciaUltLetra *)
begin
     Comenzar_MSC1(S);
     ObtenerUltimo
end;
procedure  AvanzarUltLetra;
           (* POST ultLetra es la ltima letra de la siguiente palabra,
             si la hay, y se actualiza FinDeSecuenciaUltLetra *)
begin
     ObtenerUltimo
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 5.10. Comprobar si todas las palabras acaban con   *****');
     writeln('*****                 la misma letra (primer modelo, con secuencia *****');
     writeln('*****                 intermedia formada por las ultimas letras    *****');
     writeln('*****                 de cada palabra)                             *****');
     writeln('*****');
     writeln;
     TratamientoInicial_MSC1(S);
     Cargar_fichero_MSC1(S,'dat5_10.txt');
     write('La secuencia de entrada es: ');
     Comenzar_MSC1 (S);
     while (EA_MSC1 (S) <> MSC1_MarcaFin) do begin
                write(EA_MSC1(S));
       		Avanzar_MSC1 (S)
     end;
     writeln;

     ComenzarUltLetra;
     if FinDeSecuenciaUltLetra then write('No hay palabras')
     else begin
               ultLetraPrimPal := ultLetra;
               repeat
	             AvanzarUltLetra
	       (* INV Todas las letras de Piz son iguales a ultLetraPrimPal *)
	       until FinDeSecuenciaUltLetra or (ultLetra <> ultLetraPrimPal);
               writeln;
	       if FinDeSecuenciaUltLetra then
                   write('Todas las palabras terminan en la misma letra')
	       else
                   write('Todas las palabras no terminan en la misma letra')
     end;
     writeln;
     writeln;
     write('Pulse enter para continuar');
     readln
end.
