program Algoritmo5_4;
(*
 * Algoritmo 5.4. Calcular el numero de pares (cuarto modelo, segundo esquema)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 5. Tecnicas de disenyo de algoritmos
 * Fichero de entrada: datos5_4.txt
 *)

uses crt, unitmse1;

const
     MSE4_MarcaFin = MSE1_MarcaFin;
var
   a, b : integer;
   numA, numB : integer;
   numPares : integer;
   S : mse1;

(*
 * Maquina abstracta del cuarto modelo a partir de
 * una maquina secuencial del primer modelo
 *)
   comenzar : boolean;
procedure TratamientoInicial_MSE4(VAR S : mse1);
begin
     TratamientoInicial_MSE1(S);
end;

procedure Iniciar_MSE4(VAR S : mse1);
begin
     Comenzar_MSE1(S);
     comenzar := false;
end;

procedure Avanzar_MSE4(VAR S : mse1);
begin
     if not comenzar then comenzar := true
     else Avanzar_MSE1(S);
end;

function EA_MSE4(VAR S : mse1) : integer;
begin
     EA_MSE4 := EA_MSE1 (S);
end;

procedure Cargar_Fichero_MSE4(var S : mse1; nombre : string);
begin
     Cargar_Fichero_MSE1(S, nombre);
end;

function EsVacia_MSE4(S : mse1) : boolean;
begin
     EsVacia_MSE4 := EA_MSE1(S) = MSE1_MarcaFin;
end;


begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 5.4. Calcular el numero de pares      *****');
     writeln('*****                (cuarto modelo, segundo esquema) *****');
     writeln('*****');
     writeln;
     writeln('Introduzca un par de enteros distintos:');
     write('   primer entero: ');
     readln(a);
     write('   segundo entero: ');
     readln(b);
     writeln;
     write('La secuencia de entrada es: ');
     TratamientoInicial_MSE4(s);
     Cargar_fichero_MSE4(S,'datos5_4.txt');
     Iniciar_MSE4(S);
     if EsVacia_MSE4(S) then write('Secuencia vacia')
     else begin
         numPares := 0;
	 numA := 0;
	 numB := 0;
	 Avanzar_MSE4(S);
	 REPEAT
               if EA_MSE4(S) = a then begin
                                 numPares := numPares + numB;
                                 numA := numA + 1
               end
               else if EA_MSE4(S) = b then begin
                                      numPares := numPares + numA;
                                      numB := numB + 1
               end;
               write(EA_MSE4(S), ' ');
               Avanzar_MSE4 (S);
	 UNTIL EA_MSE4(S) = MSE4_MarcaFin;
         writeln;
         writeln;
         writeln('El numero de pares (', a,', ', b, '), (', b, ', ', a, ') es: ', numPares);
     end;
     writeln;
     write('Pulse enter para continuar');
     readln
end.


