program Algoritmo5_7;
(*
 * Algoritmo 5.7. Calculo posicion de la primera palabra que comienza por 'a'
 *                (primer modelo, primer esquema)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 5. Tecnicas de disenyo de algoritmos
 * Fichero de entrada: datos5_7.txt
 *)

uses crt, unitmsc1;

const
     ESPACIO = ' ';
var
     posicion : integer;
     anterior : char;
     S : msc1;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 5.7. Calculo posicion de la primera palabra               *****');
     writeln('*****                que comienza por "a" (primer modelo, primer esquema) *****');
     writeln('*****');
     writeln;
     write('La secuencia de entrada es: ');
     TratamientoInicial_MSC1(S);
     Cargar_fichero_MSC1(S,'datos5_7.txt');
     Comenzar_MSC1 (S);
     while (EA_MSC1 (S) <> MSC1_MarcaFin) do begin
                write(EA_MSC1(S));
       		Avanzar_MSC1 (S)
     end;
     writeln;
     Comenzar_MSC1 (S);
     posicion := 0;
     anterior := ESPACIO;
     while (EA_MSC1 (S) <> MSC1_MarcaFin) and
           not ((EA_MSC1 (S) = 'a') and (anterior = ESPACIO)) do begin
       		posicion := posicion + 1;
       		anterior := EA_MSC1 (S);
       		Avanzar_MSC1 (S)
     (* INV "En Piz ninguna palabra empieza por 'a'" y posicion = Long (Piz) *)
     end;
     if EA_MSC1 (S) = MSC1_MarcaFin then
      	 write('El texto no contiene ninguna palabra que comience por la letra a')
     else
         write('Posicion de la primera palabra que comienza por "a" es: ', posicion+1);
     writeln;
     writeln;
     write('Pulse enter para continuar');
     readln
end.
