program Algoritmo6_1;
(*
 * Algoritmo 6.1. Mostrar la nota de un alumno (version 1)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 6. Tablas
 * Fichero de entrada: datos6_1.dat
 *)

(* Para generar el fichero datos6_1.dat emplear el programa genf6_1.pas   *)
(* Para consultar el fichero datos6_1.dat emplear el programa verf6_1.pas *)
(* En este algoritmo se ha sustituido la secuencia de NotaAlumno
   por un fichero secuencial, 'datos6_1.dat' *)

uses crt;

const
     MAX_ALUMNOS = 200;

type
    NotaAlumno = record
                       codigo : 1..MAX_ALUMNOS;
                       nota : real;
    end;
var
    f : file of NotaAlumno;
    alum : NotaAlumno;
    cod : 1..MAX_ALUMNOS;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 6.1. Mostrar la nota de un alumno (version 1) *****');
     writeln('*****');
     writeln;
     assign(f,'datos6_1.dat');
     reset(f);
     write('Introduzca el codigo del alumno (>= 1) (<= ', MAX_ALUMNOS, '): ');
     readln(cod);
     if eof(f) then writeln('El fichero esta vacio')
     else begin
               repeat
                     read(f,alum);
               until (eof(f)) or (alum.codigo = cod);
               (* Si el codigo es el ultimo, eof sera TRUE,
                  por ello debemos preguntar por alum.codigo
                  para determinar su presencia *)
               writeln;
               if (alum.codigo <> cod) then writeln('No existe ese codigo')
	       else writeLn('La nota de este alumno es: ',alum.nota:1:2);
     end;
     writeln;
     write('Pulse enter para continuar');
     readln

end.
