program Algoritmo6_10;
(*
 * Algoritmo 6.10. Calculo del peso del segmento de mayor peso
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 6. Tablas
 *)

uses crt;

const
     LMAX = 100;
type
    Rango = 1..LMAX;
    Vector = array [Rango] of integer;
var
   t : Vector;
   pesoMaximo : integer;  (* peso mayor de los segmentos de la secuencia *)
   pesoMaximoSegAct : integer;	(* peso mayor de los segmentos actuales *)
   i, long : Rango;

procedure Leer(VAR a : Vector; n : Rango);
var
   i : Rango;
begin
     for i := 1 to n do begin
         write('  Introduzca componente ',i,': ');
         readln(a[i]);
     end;
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 6.10. Calculo del peso del segmento de mayor peso *****');
     writeln('*****');
     writeln;
     write('Introduce el numero de elementos: ');
     readln(long);
     Leer(t, long);
     if long = 0 then writeln('Secuencia vacia')
     else begin
               pesoMaximo := t[1];
               pesoMaximoSegAct := t[1];
               for i:= 2 to long do begin
                   if t[i] > t[i] + pesoMaximoSegAct
                      then pesoMaximoSegAct := t[i]
                   else pesoMaximoSegAct := pesoMaximoSegAct + t[i];
                   if pesoMaximo < pesoMaximoSegAct
                      then pesoMaximo := pesoMaximoSegAct;
               end;
               writeln;
               writeln('El peso del segmento de mayor peso es: ', pesoMaximo);
     end;
     writeln;
     write('Pulse enter para continuar');
     readln
end.
