program Algoritmo6_16;
(*
 * Algoritmo 6.16. Suma de los valores mayores de cada fila de una matriz de enteros
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 6. Tablas
 *)

uses crt;

const
     n = 20;
     NFilas = n; (* constante con el numero de filas *)
     NColumnas = n; (* constante con el numero de columnas *)

type
    RangoFilas = 1..NFilas;
    RangoColumnas = 1..NColumnas;
    Vector = array [RangoFilas, RangoColumnas] of integer;
var
   t : Vector;
   nf, i : RangoFilas;
   nc, j : RangoColumnas;
   sm, mayor: integer;

procedure Leer(VAR a : Vector; nf : RangoFilas; nc : RangoColumnas);
var
   i : RangoFilas;
   j : RangoColumnas;

begin
     for i:=1 to nf do begin
         writeln;
         writeln('Fila: ',i);
         for j:=1 to nc do begin
             write('Introduzca elemento (',i,', ', j,'): ');
             readln(a[i, j]);
         end;

     end;
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 6.16. Suma de los valores mayores de cada fila *****');
     writeln('*****                 de una matriz de enteros                 *****');
     writeln('*****');
     writeln;
     write('Introduzca el numero de filas (<= ',n,'): ');
     readln(nf);
     writeln;
     write('Introduzca el numero de columnas (<= ',n,'): ');
     readln(nc);
     Leer(t, nf, nc);
     sm := 0;
     for i := 1 to nf do begin
         mayor := t[i,1];
         for j := 2 to nc do begin
             if mayor < t[i,j] then mayor := t[i,j]
             (* INVint  mayor = mayor de los j elementos ya recorridos
                        de la fila i, 1 <= j <= nc *)
         end;
         sm := sm + mayor
         (* INVext  sm = suma de los mayores de las primeras
                    i filas de T, 1 <= i <= nf *)
     end;
     (* INVext y (i = nf) => POST *)
     writeln;
     writeln('La suma de los valores mayores de cada fila de');
     writeln('la matriz de enteros es: ', sm);
     writeln;
     write('Pulse enter para continuar');
     readln
end.
