program Algoritmo6_5;
(*
 * Algoritmo 6.5. Porcentaje de mujeres y hombres, y nota media de cada sexo
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 6. Tablas
 * Fichero de entrada: datos6_4.dat
 *)

(* Para generar el fichero datos6_4.dat emplear el programa genf6_4.pas   *)
(* Para consultar el fichero datos6_4.dat emplear el programa verf6_4.pas *)

uses crt;
const
     MAX_ESTUDIANTES = 100;
type
    Estudiante = record
                       nombre: string;
		       edad : integer;
		       sexo : Boolean;	        (* verdadero si es mujer, falso si es hombre *)
		       nota : Real;
                 end;
    Festudiantes = file of Estudiante;
    NumEstudiantes = 0..MAX_ESTUDIANTES;
    Curso = array [1.. MAX_ESTUDIANTES] of Estudiante;
var
    c : Curso;
    contaM, contaH : 0..MAX_ESTUDIANTES; 	(* contadores numero de mujeres y hombres *)
    sumaM, sumaH : Real;		        (* contadores notas de mujeres y hombres *)
    mujeres, hombres : Real;		        (* porcentajes de mujeres y hombres *)
    long : NumEstudiantes;	                (* longitud de la secuencia almacenada *)
    i : 1..MAX_ESTUDIANTES;                     (* indice para la tabla *)

procedure Leer(var c : Curso; var l : NumEstudiantes);
var
   f : Festudiantes;
begin
     assign(f,'datos6_4.dat');
     reset(f);
     l := 0;
     while (not eof(f)) and (l < MAX_ESTUDIANTES) do begin
           l := l + 1;
           read(f, c[l]);
     end;
     close(f);
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 6.5. Porcentaje de mujeres y hombres, *****');
     writeln('*****                y nota media de cada sexo        *****');
     writeln('*****');
     writeln;
     (* Se introducen los datos de long estudiantes en la tabla c *)
     Leer (c, long);
     case long of
          0    : writeln('No hay alumnos');
          else   begin
                      sumaM := 0; sumaH := 0;
	              contaM := 0; contaH := 0;
                      for i := 1 to long do
                          if c[i].sexo then begin
			                         sumaM := sumaM + c[i].nota;
				                 contaM := contaM + 1;
                          end
		          else begin
                                    sumaH := sumaH + c[i].nota;
				    contaH := contaH + 1
                          end;
                      mujeres := contaM / long * 100;
                      hombres := contaH / long * 100;
                      writeln('Porcentaje de mujeres: ', mujeres:1:2, '%');
                      writeln;
                      writeln('Porcentaje de hombres: ', hombres:1:2, '%');
                      if contaM <> 0 then begin
                              writeln;
                              writeln('Nota media de las mujeres: ', sumaM/contaM:1:2);
                      end;
                      if contaH <> 0 then begin
                         writeln;
                         writeln('Nota media de los hombres: ', sumaH/contaH:1:2);
                      end;
          end;
     end;
     writeln;
     write('Pulse enter para continuar');
     readln
end.

