program Algoritmo6_8;
(*
 * Algoritmo 6.8. Calcular la fecha a partir de la posicion del dia en el anyo (version 1)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 6. Tablas
 *)

uses crt;

type
    MesAnyo = 1..12;
    DiaAnyo = 1..365;
    Diames = 1..31;
const
     tp : array [MesAnyo] of integer = ( 1, 32, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335 );
var
   p : DiaAnyo;
   i : MesAnyo;
   mes : MesAnyo;
   dia : Diames;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 6.8. Calcular la fecha a partir de la posicion *****');
     writeln('*****                del dia en el anyo (version 1)            *****');
     writeln('*****');
     writeln;
     write('Introduzca la posicion del dia en el anyo: ');
     readln (p);
     i := 2;
     while (i <> 12) and (tp [i] <= p) do
           (* INV (j: 1 <= j < i : p >= tp[j]) *)
           i := i + 1;

     if tp[i] > p then mes := i - 1
                  else mes := 12;
     dia := p - tp[mes] + 1;
     writeln;
     writeln('Dia ',dia,' del mes ', mes);
     writeln;
     write('Pulse enter para continuar');
     readln
end.
