program Algoritmo7_1;
(*
 * Algoritmo 7.1. Funcion factorial recursiva
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 7. Disenyo recursivo
 *)

uses crt;

var
   n : integer;

function Factorial (n : integer): longint;
(* PRE:  n >= 0 *)
(* POST:  Factorial (n) = n! *)
var
   resultado : longint;
begin
	if n = 0 then resultado := 1
        else if n > 0 then resultado := n * Factorial (n-1);
	Factorial := resultado;
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 7.1. Funcion factorial recursiva *****');
     writeln('*****');
     writeln;
     write('Introduzca un entero (>= 0) y (<= 16): ');
     readln(n);
     writeln;
     writeln('El factorial de ', n, ' es: ', Factorial (n));
     writeln;
     write('Pulse enter para continuar');
     readln;
end.

