program Algoritmo7_10;
(*
 * Algoritmo 7.10. Funcion interfaz para la funcion del Algoritmo 7.9
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 7. Disenyo recursivo
 *)

uses crt;

var
   n : integer;

(*
 * Pascal no admite que una funcion devuelve un valor de un tipo registro,
 * Por este motivo la funcion iFibo se ha convertido en un procedimiento con
 * dos parametros paso por variable
 *)
procedure iFibo (n : integer; VAR a, b : longint);
(* PRE  n > 0 *)
(* POST  <a, b> = < Fibo(n), Fibo(n-1) > *)
var
	fib, fibAnt : longint;
begin
	if n = 1 then begin
           a := 1;
           b := 1; (* a = Fibo(1), b = Fibo(0) *)
        end
	else begin (* n > 1 *)
		iFibo (n - 1, fib, fibAnt);
			(*
			 * tenemos: fib = Fibo(n-1) y fibAnt = Fibo(n-2), luego:
			 * Fibo(n) = Fibo(n-1) + Fibo(n-2) = fib + fibAnt
			 * Fibo(n-1) = fib :
			 *)
		a := fib + fibAnt; b := fib;
	end
end;

function Finterf (n : integer) : longint;
(* PRE  n > 0 *)
(* POST  Finterf (n) = Fibo(n) *)

var
	fib, fibAnt : longint;
begin
	if n = 0 then Finterf := 1
	else begin (* n > 0 *)
		(* se llama a iFibo y se descarta su segundo resultado *)
		iFibo (n, fib, fibAnt);
	        Finterf := fib
        end
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 7.10. Funcion interfaz para la funcion *****');
     writeln('*****                 del Algoritmo 7.9                *****');
     writeln('*****');
     writeln;
     write('Termino de la sucesion que se desea calcular (>= 0): ');
     readln(n);
     writeln;
     writeln('El termino ', n, '-esimo (posicion ', n+1, ') de la sucesion es: ', Finterf (n));
     writeln;
     write ('Pulse enter para continuar');
     readln
end.







