program Algoritmo7_11;
(*
 * Algoritmo 7.11. Funcion potencia natural mejorada
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 7. Disenyo recursivo
 *)

uses crt;

var
   base : real;
   exponente : integer;

function PotNat (a : real; n : integer) : real;
(* PRE  (n >= 0) y (n = 0 => a <> 0) *)
(* POST  PotNat(a, n) = a elevado a n *)

var
   p : real;
begin
     if n = 0 then
        PotNat := 1.0
     else (* n > 0 *) begin
        p := PotNat (a, n div 2);
        if n mod 2 = 0 then PotNat := p * p
	else PotNat := a * p * p
    end;
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 7.11. Funcion potencia natural mejorada *****');
     writeln('*****');
     writeln;
     write('Introduzca un real como base de la potencia: ');
     readln(base);
     writeln;
     write('Introduzca un entero como exponente de la potencia (>= 0): ');
     readln(exponente);
     writeln;
     writeln('Resultado: ', PotNat(base, exponente):1:2);
     writeln;
     write ('Pulse enter para continuar');
     readln
end.


