program Algoritmo7_2;
(*
 * Algoritmo 7.2. Funcion division natural recursiva
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 7. Disenyo recursivo
 *)

uses crt;

var
   dividendo, divisor, cociente, resto : integer;

(*
 * Pascal no admite que una funcion devuelve un valor de un tipo registro,
 * Por este motivo la funcion DivisionNatural se ha convertido en un procedimiento
 * con dos parametros paso por variable
 *)
procedure DivisionNatural (num, den : integer; VAR coc, res : integer);
(* PRE: (num >= 0) y (den > 0) *)
(* POST: DivisionNatural (num,den) = <c, r> y num = c * den + r y 0 <= r < den *)
begin
     if num < den then begin
          coc := 0;
          res := num
     end
     else begin
          DivisionNatural(num-den, den, coc, res);
          coc := coc + 1
     end
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 7.2. Funcion division natural recursiva *****');
     writeln('*****');
     writeln;
     write('Introduzca el dividendo (>= 0): ');
     readln(dividendo);
     writeln;
     write('Introduzca el divisor (> 0): ');
     readln(divisor);
     DivisionNatural(dividendo, divisor, cociente, resto);
     writeln;
     writeln('Resultado: cociente = ', cociente, ', resto = ', resto);
     writeln;
     write('Pulse enter para continuar');
     readln;
end.





