program Algoritmo7_3;
(*
 * Algoritmo 7.3. Funcion producto escalar recursiva lineal
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 7. Disenyo recursivo
 *)

uses crt;

const
     MAX = 10;

type
    Vector = array [1..MAX] of real;

var
   vv1, vv2 : Vector;
   n, i : integer;

function pei (v1, v2 : Vector; a, b : integer) : real;
	(* PRE  1 <= a <= b <= MAX, y v1 y v2 tienen valores significativos en [a, b] *)
	(* POST  pei (v1, v2, a, b) = sumatorio desde i = a hasta b de v1[i] * v2[i] *)
begin
	if a = b then pei := v1[a] * v2[a]
	else (* a < b *) pei := v1[a] * v2[a] + pei (v1, v2, a+1, b)
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 7.3. Funcion producto escalar recursiva lineal *****');
     writeln('*****');
     writeln;
     write('Introduzca el numero de elementos de los vectores (> 0) y (<=',MAX,'): ');
     readln(n);
     writeln;
     writeln('Primer vector');
     for i := 1 to n do begin
        write('   Componente ', i, ': ');
        readln(vv1[i]);
     end;
     writeln;
     writeln('Segundo vector');
     for i := 1 to n do begin
        write('   Componente ', i, ': ');
        readln(vv2[i]);
     end;
     writeln;
     writeln('El producto escalar de los vectores es: ', pei (vv1, vv2, 1, n):1:2);
     writeln;
     write('Pulse enter para continuar');
     readln;
end.
