program Algoritmo7_7;
(*
 * Algoritmo 7.7. Funcion producto escalar iterativa (version 2)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 7. Disenyo recursivo
 *)

uses crt;

const
     MAX = 10;

type
    Vector = array [1..MAX] of real;

var
   vv1, vv2 : Vector;
   n, i : integer;

function  pe (v1, v2 : Vector) : real;
var
	a, b : integer;
	c : real;
begin
	a := 1; b := MAX; c := 0;
	while a <= b do begin
		c := c + v1[a] * v2[a];
		a := a + 1
	end;
	pe := c
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 7.7. Funcion producto escalar iterativa (version 2) *****');
     writeln('*****');
     writeln;
     write('Introduzca el numero de elementos de los vectores (> 0) y (<=',MAX,'): ');
     readln(n);
     writeln;
     writeln('Primer vector');
     for i := 1 to n do begin
        write('   Componente ', i, ': ');
        readln(vv1[i]);
     end;
     writeln;
     writeln('Segundo vector');
     for i := 1 to n do begin
        write('   Componente ', i, ': ');
        readln(vv2[i]);
     end;
     writeln;
     writeln('El producto escalar de los vectores es: ', pe (vv1, vv2):1:2);
     writeln;
     write('Pulse enter para continuar');
     readln;
end.





