program Algoritmo7_8;
(*
 * Algoritmo 7.8. Funcion potencia natural recursiva
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 7. Disenyo recursivo
 *)

uses crt;

var
   base : real;
   exponente : integer;

function PotenciaNatural (a : real; n : integer) : real;
(* PRE  (n >= 0) y (n = 0 => a <> 0) *)
(* POST  PotenciaNatural(a, n) = a elevado a n *)

begin
     if n = 0 then
        PotenciaNatural := 1.0
     else (* n > 0 *)
        PotenciaNatural := a * PotenciaNatural(a, n-1);
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 7.8. Funcion potencia natural recursiva *****');
     writeln('*****');
     writeln;
     write('Introduzca un real como base de la potencia: ');
     readln(base);
     writeln;
     write('Introduzca un entero como exponente de la potencia (>= 0): ');
     readln(exponente);
     writeln;
     writeln('Resultado: ', PotenciaNatural(base, exponente):1:2);
     writeln;
     write('Pulse enter para continuar');
     readln

end.

