program Algoritmo7_9;
(*
 * Algoritmo 7.9. Calculo recursivo de Fibo(n) con inmersion de resultados por eficiencia
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 7. Disenyo recursivo
 *)

uses crt;

var
   n, fib, fibAnt : integer;

(*
 * Pascal no admite que una funcion devuelve un valor de un tipo registro,
 * Por este motivo la funcion iFibo se ha convertido en un procedimiento con
 * dos parametros paso por variable
 *)
procedure iFibo (n : integer; VAR a, b : integer);
(* PRE  n > 0 *)
(* POST  <a, b> = < Fibo(n), Fibo(n-1) > *)
var
	fib, fibAnt : integer;

begin
	if n = 1 then begin
           a := 1;
           b := 1; (* iF = < Fibo(1), Fibo(0) > *)
        end
	else (* n > 1 *) begin
		iFibo (n - 1, fib, fibAnt);
			(*
			 * tenemos: fib = Fibo(n-1) y fibAnt = Fibo(n-2), luego:
 			 * Fibo(n) = Fibo(n-1) + Fibo(n-2) = fib + fibAnt
			 * Fibo(n-1) = fib :
			 *)
		a := fib + fibAnt;
                b := fib;
	end
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 7.9. Calculo recursivo de Fibo(n) con inmersion *****');
     writeln('*****                de resultados por eficiencia               *****');
     writeln('*****');
     writeln;
     write('Termino de la sucesion que se desea calcular (> 0): ');
     readln(n);
     writeln;
     iFibo (n, fib, fibAnt);
     writeln('El termino ', n, '-esimo (posicion ', n+1, ') de la sucesion es: ', fib);
     writeln;
     write('Pulse enter para continuar');
     readln
end.

